' 
' ####################
' #####  PROLOG  #####
' ####################
' 
' A demo of adding version information to a resource file
' and then extracting the information using GetFileVersionInfoA().
' 
VERSION "0.0001"
CONSOLE
' 
IMPORT "xst"
IMPORT "xsx"
IMPORT "version"

' IMPORT "xst_s.lib"
' IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

DECLARE FUNCTION Entry ()
DECLARE FUNCTION GetVersionInfo (sFile$, @fileVersion$, @productVersion$, @fileDescription$)

FUNCTION Entry ()

	ret = GetVersionInfo ("version.exe", @fileVersion$, @productVersion$, @fileDescription$)
	? fileVersion$
	? productVersion$
	? fileDescription$

	a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

FUNCTION GetVersionInfo (sFile$, @fileVersion$, @productVersion$, @fileDescription$)
	' Returns file version, product version and description

	VS_FIXEDFILEINFO verinf

	bufsize = GetFileVersionInfoSizeA (&sFile$, &vHnd)

	IF bufsize > 0 THEN

		vinfo$ = NULL$ (bufsize)

		IF GetFileVersionInfoA (&sFile$, vHnd, bufsize, &vinfo$) THEN
			IF VerQueryValueA (&vinfo$, &"\\VarFileInfo\\Translation", &vptr, &vlen) THEN
				buf$ = NULL$ (vlen)
				IFZ XstCopyMemory (vptr, &buf$, vlen) THEN
					' Obtain language ID and codepage
					DIM x$[4]
					FOR x = 0 TO 3
						nAsc = buf${x}
						IF nAsc > 0xF THEN
							x$[x] = HEX$ (nAsc)
						ELSE
							x$[x] = "0" + HEX$ (nAsc)
						END IF
					NEXT
					LangStr$ = x$[1] + x$[0] + x$[3] + x$[2]

					' Obtain fileVersion information
					buf$ = "\\StringFileInfo\\" + LangStr$ + "\\FileVersion"
					lResult = VerQueryValueA (&vinfo$, &buf$, &vptr, &vlen)
					buf$ = NULL$ (vlen)
					XstCopyMemory (vptr, &buf$, vlen)
					fileVersion$ = CSIZE$ (buf$)
									
					' Obtain productVersion information
					buf$ = "\\StringFileInfo\\" + LangStr$ + "\\ProductVersion"
					lResult = VerQueryValueA (&vinfo$, &buf$, &vptr, &vlen)
					buf$ = NULL$ (vlen)
					XstCopyMemory (vptr, &buf$, vlen)
					productVersion$ = CSIZE$ (buf$)

					' Obtain file description string
					buf$ = "\\StringFileInfo\\" + LangStr$ + "\\FileDescription"
					lResult = VerQueryValueA (&vinfo$, &buf$, &vptr, &vlen)
					buf$ = NULL$ (vlen)
					XstCopyMemory (vptr, &buf$, vlen)
					fileDescription$ = CSIZE$ (buf$)
					RETURN

				END IF
			END IF
		END IF
	END IF

	RETURN $$TRUE

END FUNCTION
END PROGRAM