'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Test the LED control
'
	IMPORT  "led_s.lib"
	IMPORT	"xst"   		' standard library	: required by most programs
	IMPORT  "xsx"				' extended std library
'	IMPORT	"xio"				' console io library
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll
'
DECLARE FUNCTION Entry            ()
DECLARE FUNCTION WndProc          (hwnd, msg, wParam, lParam)
DECLARE FUNCTION InitGui          ()
DECLARE FUNCTION CreateWindows    ()
DECLARE FUNCTION NewWindow        (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
DECLARE FUNCTION MessageLoop      ()

$$ID_LED4 = 100
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	STATIC	entry
'
	IF entry THEN RETURN							' enter once
	entry =  $$TRUE										' enter occured

'	XioCreateConsole (title$, 50)			' create console, if console is not wanted, comment out this line
	InitGui ()												' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create windows and other child controls
	MessageLoop ()										' the main message loop
'	XioFreeConsole ()									' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION WndProc (hWnd, msg, wParam, lParam)

	SHARED hInst
	STATIC count

	SELECT CASE msg

		CASE $$WM_CREATE :
			
			hLed1 = CreateWindowExA (0, &"ledctrl", &"0123456789", $$WS_CHILD | $$WS_VISIBLE, 20, 20, 16, 24, hWnd, 0, hInst, 0) 
			hLed2 = CreateWindowExA (0, &"ledctrl", &"9876543210", $$WS_CHILD | $$WS_VISIBLE, 20, 60, 32, 48, hWnd, 0, hInst, 0) 
			hLed3 = CreateWindowExA (0, &"ledctrl", &"333-666-9999", $$WS_CHILD | $$WS_VISIBLE, 20, 120, 24, 32, hWnd, 0, hInst, 0) 
			SendMessageA (hLed3, $$LED_SET_BORDERSTYLE, 0, $$LED_BORDERSTYLE_NONE)
			SendMessageA (hLed3, $$LED_SET_COLOR, 0, RGB(0, 255, 0))
			SendMessageA (hLed3, $$LED_SET_BKCOLOR, 0, RGB(255, 220, 220))
			hLed4 = CreateWindowExA (0, &"ledctrl", &"10", $$WS_CHILD | $$WS_VISIBLE, 20, 170, 54, 81, hWnd, $$ID_LED4, hInst, 0) 			
			SendMessageA (hLed4, $$LED_SET_BORDERSTYLE, 0, $$LED_BORDERSTYLE_RAISED)
			SendMessageA (hLed4, $$LED_SET_BKCOLOR, 0, GetSysColor($$COLOR_BTNFACE))
			SetTimer (hWnd, 1, 1000, 0)
			count = 10
			
		CASE $$WM_TIMER :
			DEC count
			IF count < 0 THEN count = 10
			t$ = FORMAT$ ("##", count)
			SetWindowTextA (GetDlgItem (hWnd, $$ID_LED4), &t$)
			
			
		CASE $$WM_DESTROY :
			PostQuitMessage(0)
			
		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT

END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION InitGui ()

	SHARED hInst

	hInst = GetModuleHandleA (0) 	' get current instance handle
	IFZ hInst THEN QUIT (0)
	Led ()
	
END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION CreateWindows ()

	' create main window
	titleBar$ 	= "LED control test"
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 400
	h 					= 300
	exStyle			= 0
	addrWndProc = &WndProc()
	icon$ 			= "scrabble"
	menu$ 			= ""
	#winMain = NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc
	
	className$ = titleBar$
	IFZ className$ THEN className$ = "Main Program"
	IF INSTR(className$, " ") THEN
		XstReplace (@className$, " ", "_", 0)
	END IF
	
	IFZ icon$ THEN icon$ = "scrabble"
	
	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = $$COLOR_BTNFACE + 1
	wc.lpszMenuName    = &menu$
	wc.lpszClassName   = &className$

	IFZ RegisterClassA (&wc) THEN RETURN
	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION MessageLoop ()

	MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN								' main program executes message loop

	DO																			' the message loop
		ret = GetMessageA (&msg, NULL, 0, 0)	' retrieve next message from queue

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam					' WM_QUIT message
			CASE -1 : RETURN $$TRUE							' error
			CASE ELSE:
				hwnd = GetActiveWindow ()
				IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN		' send only non-dialog messages
  				TranslateMessage (&msg)					' translate virtual-key messages into character messages
  				DispatchMessageA (&msg)					' send message to window callback function WndProc()
				END IF
		END SELECT
	LOOP

END FUNCTION

END PROGRAM
